/*====================================================================
EX.
%SCANPDS(DSN=SAS.SAS607.SAMPLE,STR=%NRSTR(PLOT),UPCASE=NO,REPORT=YES);
====================================================================*/

%MACRO SCANPDS(DSN=,STR=,UPCASE=YES,REPORT=YES);

 OPTIONS LS=100 PS=60 NOCENTER NODATE NONUMBER;
 FILENAME TEMP '&TEMP' DISP=NEW SPACE=(CYL,(5,5))
                       LRECL=80 BLKSIZE=6160 RECFM=FB DSORG=PS;

 PROC SOURCE INDD="&DSN" OUTDD=TEMP NOSUMMARY;
 RUN;

 PROC DATASETS NOLIST MT=DATA; DELETE _REPORT; RUN; QUIT;

 DATA WORK._REPORT;
  KEEP MEMBER LINE TEXT;
  LENGTH MEMBER $ 8;
  RETAIN MEMBER;
  INFILE TEMP;
  INPUT @1 TEXT $CHAR80.;
  IF SCAN(TEXT,1,' =')='./'
   & SCAN(TEXT,2,' =')='ADD'
   & SCAN(TEXT,3,' =')='NAME' THEN DO;
   MEMBER=SCAN(TEXT,2,'=');
   LINE=0;
   DELETE;
  END;
  LINE+1;
 %IF &UPCASE=YES %THEN %DO;
  IF KINDEX(KUPCASE(TEXT),KUPCASE("&STR"));
 %END;
 %ELSE %DO;
  IF KINDEX(TEXT,"&STR");
 %END;
  TEXT=LEFT(TEXT);
 RUN;

 %IF &REPORT=YES %THEN %DO;
 OPTIONS LS=132 PS=60 NOCENTER DATE NUMBER PAGENO=1;
 TITLE1 "DATASET NAME:&DSN / SEARCH STRING:&STR";
 PROC PRINT DATA=WORK._REPORT UNIFORM;
  VAR MEMBER LINE TEXT;
 RUN;
 TITLE1;
 %END;

%MEND SCANPDS;
